import { App, Controller, Get, Inject } from '@midwayjs/decorator';
import { resolve } from 'path'
import * as fs from 'fs'
import { Application, Context } from '@midwayjs/koa';
// import { ENV_TYPE } from '../const';


@Controller('/')
export class HomeController {
  @App()
  app: Application;
  @Inject()
  ctx: Context
  @Get('/page/*')
  async home(): Promise<string> {

    const vite: any = this.app.getAttr('vite')

    let template = fs.readFileSync(resolve(process.cwd(), './web/index.html'), 'utf-8')
    template = await vite.transformIndexHtml("/", template)


    let render = (await vite.ssrLoadModule(resolve(process.cwd(), './web/entry-server.ts'))).render

    const [appHtml] = await render(this.ctx)

    const html = template
      .replace(`<!--app-html-->`, appHtml)

    return html;
  }
}
